from marshmallow import Schema, fields
from ShopifyTupperware.models.address_model import AddressSchema

class CustomerSchema(Schema):
    id =  fields.Integer()
    first_name =  fields.String()
    last_name =  fields.String()
    email =  fields.String()
    phone =  fields.String()
    accepts_marketing =  fields.Boolean()
    created_at =  fields.String()
    updated_at =  fields.String()
    orders_count =  fields.Integer()
    state =  fields.String()
    total_spent =  fields.Float()
    last_order_id =  fields.Integer()
    note =  fields.String()
    verified_email =  fields.Boolean()
    multipass_identifier =  fields.String()
    tax_exempt =  fields.Boolean()
    tags =  fields.String()
    last_order_name =  fields.String()
    currency =  fields.String()
    accepts_marketing_updated_at =  fields.String()
    marketing_opt_in_level =  fields.String()
    addresses =  fields.List(fields.Nested(AddressSchema))
    default_address =  fields.Nested(AddressSchema)

class Customer2Schema(CustomerSchema):
    password= fields.String()
    password_confirmation= fields.String()
    send_email_invite = fields.Boolean()
    send_email_welcome = fields.Boolean()

class GiftCardSchema(Schema):
    id=  fields.Integer()
    balance= fields.String()
    created_at= fields.String()
    updated_at= fields.String()
    currency= fields.String()
    initial_value= fields.String()
    disabled_at= fields.String()
    line_item_id=  fields.Integer()
    api_client_id=  fields.Integer()
    user_id=  fields.Integer()
    customer_id=  fields.Integer()
    note= fields.String()
    expires_on= fields.String()
    template_suffix= fields.String()
    last_characters= fields.String()
    order_id=  fields.Integer()
    code= fields.String()
