from marshmallow import Schema, fields
from ShopifyTupperware.models import variant_model, image_model, option_model

class ProductSchema(Schema):
    key = fields.Integer()
    id = fields.Integer()
    title = fields.String()
    body_html = fields.String()
    vendor = fields.String()
    product_type = fields.String()
    handle = fields.String()
    template_suffix = fields.String()
    tags = fields.String()
    published_scope = fields.String()
    created_at = fields.String()
    updated_at = fields.String()
    published_at = fields.String()
    published = fields.Boolean()
    images = fields.List(fields.Nested(image_model.ImageSchema))
    image = fields.Nested(image_model.ImageSchema)
    variants = fields.List(fields.Nested(variant_model.VariantSchema))
    options = fields.List(fields.Nested(option_model.OptionSchema))

class ProductSchema2(Schema):
    key = fields.Integer()
    id = fields.Integer()
    title = fields.String()
    body_html = fields.String()
    vendor = fields.String()
    product_type = fields.String()
    handle = fields.String()
    template_suffix = fields.String()
    tags = fields.String()
    published_scope = fields.String()
    created_at = fields.String()
    updated_at = fields.String()
    published_at = fields.String()
    published = fields.Boolean()
    product_images = fields.List(fields.Nested(image_model.ProductImageSchema))
    image = fields.Nested(image_model.ProductImageSchema)
    variants = fields.List(fields.Nested(variant_model.VariantSchema))
    options = fields.List(fields.Nested(option_model.OptionSchema))
