from marshmallow import Schema, fields
from ShopifyTupperware.models.price_model import PresentmentPriceSchema

class VariantSchema(Schema):
    id = fields.Integer()
    product_id = fields.Integer()
    title = fields.String()
    price = fields.Float()
    sku = fields.String()
    position = fields.Integer()
    inventory_policy = fields.String()
    compare_at_price = fields.String()
    fulfillment_service = fields.String()
    inventory_management = fields.String()
    option1 = fields.String()
    option2 = fields.String()
    option3 = fields.String()
    created_at = fields.String()
    updated_at = fields.String()
    taxable = fields.Boolean()
    barcode = fields.String()
    grams = fields.Float()
    image_id = fields.Integer()
    weight = fields.Float()
    weight_unit = fields.String()
    inventory_item_id = fields.Integer()
    inventory_quantity = fields.Integer()
    old_inventory_quantity = fields.Integer()
    requires_shipping = fields.Boolean()
    presentment_prices = fields.List(fields.Nested(PresentmentPriceSchema))